(function() {
  var StockedItem, addItem, cleanUp, config, count, removeItem, request, stock;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  request = require('request');
  stock = {};
  count = 0;
  config = {
    shelfLife: 60,
    maxLife: 300,
    capacity: 1000,
    ideal: 900
  };
  this.configure = function(options) {
    var k, v;
    for (k in options) {
      v = options[k];
      config[k] = v;
    }
    if (!(options.ideal && config.ideal <= (config.capacity * 0.9))) {
      config.ideal = config.capacity * 0.9;
    }
    return console.log(config);
  };
  this.fetch = function(options, callback) {
    var delivered, k, stockedItem, v, _ref, _ref2;
    delivered = false;
        if ((_ref = options.key) != null) {
      _ref;
    } else {
      options.key = options.uri;
    };
    for (k in config) {
      v = config[k];
            if ((_ref2 = options[k]) != null) {
        _ref2;
      } else {
        options[k] = v;
      };
    }
    stockedItem = stock[options.key];
    if (stockedItem && !stockedItem.hasSpoiled()) {
      callback(null, stockedItem.item);
      delivered = true;
    }
    if (stockedItem && !stockedItem.hasExpired()) {
      return;
    }
    return request(options, __bind(function(error, response, body) {
      var item;
      item = JSON.parse(body);
      if (stockedItem) {
        stockedItem.reStock(item);
        console.log("Re-Stocked (" + count + "): " + options.key);
      } else {
        addItem(item, options);
        console.log("New Stock (" + count + "): " + options.key);
      }
      if (!delivered) {
        return callback(error, item);
      }
    }, this));
  };
  addItem = function(item, options) {
    stock[options.key] = new StockedItem(item, options);
    count++;
    return cleanUp();
  };
  removeItem = function(key) {
    delete stock[key];
    return count--;
  };
  cleanUp = function() {
    var expired, item, key, _i, _len, _results;
    if (count > config.capacity) {
      console.log("We're over capacity " + count + " / " + config.ideal + ".  Time to clean up the pantry");
      expired = [];
      for (key in stock) {
        item = stock[key];
        if (item.hasSpoiled()) {
          console.log("\tSpoiled: " + key);
          removeItem(key);
        } else if (item.hasExpired()) {
          expired.push(key);
        }
      }
      if (count > config.capacity) {
        for (_i = 0, _len = expired.length; _i < _len; _i++) {
          key = expired[_i];
          console.log("\tExpired: " + key);
          removeItem(key);
          if (count <= config.ideal) {
            break;
          }
        }
      }
      if (count > config.capacity) {
        _results = [];
        for (key in stock) {
          item = stock[key];
          console.log("\tTossed: " + key);
          removeItem(key);
          if (count <= config.ideal) {
            break;
          }
        }
        return _results;
      }
    }
  };
  StockedItem = (function() {
    function StockedItem(item, options) {
      this.options = options;
      this.firstPurshased = new Date();
      this.lastPurchased = new Date(this.firstPurchased);
      this.reStock(item);
    }
    StockedItem.prototype.hasExpired = function() {
      return this.hasSpoiled() || (new Date()) > this.bestBefore;
    };
    StockedItem.prototype.hasSpoiled = function() {
      return (new Date()) > this.spoilesOn;
    };
    StockedItem.prototype.reStock = function(item) {
      this.item = item;
      if (this.lastPurchased) {
        this.lastPurchased = new Date();
      } else {
        this.lastPurchased = new Date(this.firstPurchased);
      }
      this.lastUsed = new Date(this.lastPurchased);
      this.bestBefore = new Date(this.lastPurchased);
      this.bestBefore.setSeconds(this.bestBefore.getSeconds() + this.options.shelfLife);
      this.spoilesOn = new Date(this.lastPurchased);
      return this.spoilesOn.setSeconds(this.spoilesOn.getSeconds() + this.options.maxLife);
    };
    return StockedItem;
  })();
}).call(this);
